#include <stdio.h>
#include <stdlib.h>
#include <math.h>

double lfactorial(int n);

int main(int argc, char *argv[]) {
  int n;
  double lf, lf10;
  int potenza10;
  double mantissa;
  
  if (argc < 2) {
    puts("Devi dare anche l'intero di cui calcolare il fattoriale");
    return(0);
  }

  n = atoi(argv[1]);
  
  if (n<0) {
    puts("l'intero non può essere negativo");
    return(0);
  }
  
  // printf("n = %d\n", n);

  lf = lfactorial(n);
  printf("log(%d!) = %e\n", n, lf);

  lf10 = lf / log(10.);
  printf("log10(%d!) = %e\n", n, lf10);
  potenza10 = lf10;
  mantissa = pow(10., lf10 - (float) potenza10 );
  printf("%d! = %.5fe+%d\n", n, mantissa, potenza10);
  
  return(0);
}

double lfactorial(int n) {
  int i;
  double s=0;

  if (n < 2) return(0);
  
  for (i=1; i<=n; i++) {
    s +=  log( (double) i);
  }

  return(s);  
}
